/**
 * This file is part of the OpenVIDIA project at http://openvidia.sf.net
 * Copyright (C) 2004, James Fung
 *
 * OpenVIDIA is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * OpenVIDIA is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with OpenVIDIA; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 **/

#include "BoxApp.h"

BoxApp::BoxApp() {
  x=y=100;
  width=height=100;
}

BoxApp::~BoxApp() {
  //do nothing
}
  
// this will do a bunch of GL calls.
void BoxApp::render() {
  preRender();

  glShadeModel(GL_SMOOTH);

  glScalef(0.5,0.5,1);
  glTranslatef(0.5,0.5,0);

  glBegin(GL_QUADS);  
  glColor4f( 1.0 ,0.0,0.0,0.5); //red
  glVertex3f(0.0, 0.0, 1.0);
  glColor4f( 0.0 ,1.0,0.0,0.5); //g
  glVertex3f(1.0, 0.0, 1.0);
  glColor4f( 0.0 ,0.0,1.0,0.5);//b
  glVertex3f(1.0, 1.0, 1.0);
  glColor4f( 1.0 ,1.0,1.0,1.0);//w
  glVertex3f(0.0, 1.0, 1.0);

  glEnd();

  //orbits is raster display coords
  /* -0,0-----1,0
   * |
   * |
   *  0,1     1,1
   */

  postRender();
}



