/**
 * This file is part of the OpenVIDIA project at http://openvidia.sf.net
 * Copyright (C) 2004, James Fung
 *
 * OpenVIDIA is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * OpenVIDIA is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with OpenVIDIA; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 **/

#ifndef _CONTROL_STRUCT_H
#define _CONTROL_STRUCT_H

struct shm_interface_struct {

  int fps;
  float msec;

  bool grabDisplay;
  bool useDiagWin;
  bool runPseudo;
  bool useFPBuffer;
  bool applyParams;

};


class ControlStruct {
  protected:
    
    int fps;
    float msec;
 
  public:

    bool dblbuffer;
    struct shm_interface_struct shm;
    ControlStruct();
    void print();

    void set_useDiagWin();
    void unset_useDiagWin();
    void set_grabDisplay();
    void unset_grabDisplay();
    void set_runPseudo();
    void unset_runPseudo();
    void set_useFPBuffer();
    void unset_useFPBuffer();
    void set_applyParams();
    void unset_applyParams();
    void set_dblbuffer();
    void unset_dblbuffer();
};

#endif

