/**
 * This file is part of the OpenVIDIA project at http://openvidia.sf.net
 * Copyright (C) 2004, James Fung
 *
 * OpenVIDIA is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * OpenVIDIA is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with OpenVIDIA; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 **/

#ifndef _FRAGMENT_PROGRAM2TEX_H
#define _FRAGMENT_PROGRAM2TEX_H

#include <GL/gl.h>
#include <Cg/cgGL.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/extensions/shape.h>
#include "FragmentProgram.h"

// abstract base class
class FragmentProgram2Tex : public FragmentProgram {
 protected:
//   bool isActive;
//   CGprogram FP;
//   CGparameter FPtexCoord, FPtexture;
//   CGprofile FPprofile;
//   GLuint BoundtexName;
   CGparameter FPtexCoord2, FPtexture2;
 public:
   FragmentProgram2Tex( CGcontext fContext, 
                    CGprofile fProfile, 
                    char *FPname, 
                    GLuint texName1, GLuint texName2 );
   void activate();
   void deactivate();
};

#endif

