/**
 * This file is part of the OpenVIDIA project at http://openvidia.sf.net
 * Copyright (C) 2004, James Fung
 *
 * OpenVIDIA is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * OpenVIDIA is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with OpenVIDIA; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 **/

#include "MomentFilter.h"

MomentFilter::MomentFilter( ///Image Width, only 320 is supported
			            	int w, 
					///Image Heght, only 240 is supported
					int h, 
					///current CG context
					CGcontext fContext, 
					///Current CG profile
					CGprofile fProfile )
  : GenericFilter( w, h, fContext, fProfile, "FPsamples/FP-moment.cg")
{
  summer = new TextureSummator( w,h,w,h,fContext, fProfile, 0); 
} 
