/**
 * This file is part of the OpenVIDIA project at http://openvidia.sf.net
 * Copyright (C) 2004, James Fung
 *
 * OpenVIDIA is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * OpenVIDIA is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with OpenVIDIA; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 **/

#ifndef _MULTITEXTUREDISPLAY_H
#define _MULTITEXTUREDISPLAY_H

#include "GenericDisplay.h"
#include "fpc.h"
#include "FragmentProgram.h"
#include <time.h>
//#include "FragmentProgram2Tex.h"
//#include "FragmentProgram5Tex.h"

class MultitextureDisplay : public GenericDisplay
{
  int avg_rate;
  float decay;
 public:
  int num_textures;
  GLuint *texNames;
  MultitextureDisplay(int num_textures, int imageWinWidth, int imageWinHeight, int win);
  ~MultitextureDisplay() {};
  CFPBuffer fpbuffer;
  FragmentProgram *FPSimple;
  
  

  // implement the interface
  void initGL();
  void initGL(char *);
  void init_texture(int id, int width, int height, void *data);
  void bindTextures();
  void idleFunc();
  void render();
  void grabDisplay(float *Dm, float *Dn, float *Dt, float *Da,  int);
  void grabDisplay(unsigned char *Dm, unsigned char *Dn, unsigned char *Dt);
  void sumDisplay(float *R, float *G, float *B, float *A);
  void showstats();
  void showstats(int time);

  void activate_fpbuffer();
  void deactivate_fpbuffer();
  void printChirpMat();
  void render_to_texture(int);
  void render_to_texture(int,int,int,int,int);
  void init_texture4f(int id, int width, int height, void *data);
  void MultitextureDisplay::drawTexture( GLenum TEXTURE_UNIT ) ;
  void MultitextureDisplay::init_texture(int id, 
                                       int width, 
                                       int height, 
                                       int nchans, 
                                       void *data) ;
 
};

#endif

