/**
 * This file is part of the OpenVIDIA project at http://openvidia.sf.net
 * Copyright (C) 2004, James Fung
 *
 * OpenVIDIA is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * OpenVIDIA is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with OpenVIDIA; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 **/

#ifndef _TIMAGESENDER_H
#define _TIMAGESENDER_H

#include "ImageSender.h"

#include <cc++2/cc++/thread.h>
#include <semaphore.h>
#include <unistd.h>

using namespace std;
using namespace ost;

/*
 * The interaction model is as follows:
 *   When a result is ready at the graphics card
 *   put it in a buffer.  Each read call from rwm-cv
 *   reads the newest result.
 */

/*
 * Threaded version of XAPP
 */
  class TImageSender : public ImageSender, public Thread, public Mutex
{

 private:
  //prevent parent from being called
  void sendImages(int width, int height, 
		  void* b1, void*b2, 
		  int reqChirp, Parameters initialEstimate,
		  Parameters* converged);
public:
  Parameters newestEstimate, partialEstimate;

  bool b1_full;
  unsigned char* b1_backup;

  //name of app to execute
  TImageSender();
  ~TImageSender();

  void sendImages(int width, int height, 
		  void* b1, void*b2, 
		  int reqChirp, Parameters initialEstimate,
		  Parameters* converged, int *partial);
  void run();
};

#endif
