/**
 * This file is part of the OpenVIDIA project at http://openvidia.sf.net
 * Copyright (C) 2004, James Fung
 *
 * OpenVIDIA is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * OpenVIDIA is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with OpenVIDIA; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 **/

#ifndef _TRACKER_H
#define _TRACKER_H

#include "OrbitsInterface.h"
#include "CGDisplay.h"
#include "ControlStruct.h"

class Tracker {
 protected:
  CGDisplay *d;
  OrbitsInterface *orbits;
  float Dn[320*240];
  float Dm[320*240];
  float Dt[320*240];
  float Da[320*240];
  float tracky, trackx;

 public:
  Tracker(CGDisplay *d, OrbitsInterface *orbits);
  void estpchirp();
  void update_track( float params[8]);
  float getTrackx();
  float getTracky();
  void drawCrosshairs(float x, float y, float z, float size) ;   
};

#endif

