/**
 * This file is part of the OpenVIDIA project at http://openvidia.sf.net
 * Copyright (C) 2004, James Fung
 *
 * OpenVIDIA is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * OpenVIDIA is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with OpenVIDIA; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 **/

/** from the Nvidia Cg SDK 
 *  http://developer.nvidia.com/object/linux_cg_toolkit.html
 **/ 
#ifndef _CFPBUFFER
#define _CFPBUFFER
#include <glh/glh_extensions.h>
class CFPBuffer
{
    public:
        CFPBuffer() ;
        bool create(int w, int h);
        void activate();
        void deactivate();
        void destroy();
        int getWidth();
        int getHeight();
        ~CFPBuffer();
    
    private:
        int width;
        int height;

        Display    *m_pDisplay;
        GLXPbuffer  m_glxPbuffer;
        GLXContext  m_glxContext;

        Display    *m_pOldDisplay;
        GLXPbuffer  m_glxOldDrawable;
        GLXContext  m_glxOldContext;

        bool valid;
};
#endif
