/*****
 *       Xnee's Not an Event Emulator                                
 *                                                                   
 * Xnee enables recording and replaying of X protocol data           
 *                                                                   
 *        Copyright (C) 1999, 2000, 2001, 2002, 2003 Henrik Sandklef                    
 *                                                                   
 * This program is free software; you can redistribute it and/or     
 * modify it under the terms of the GNU General Public License       
 * as published by the Free Software Foundation; either version 2    
 * of the License, or any later version.                             
 *                                                                   
 *                                                                   
 * This program is distributed in the hope that it will be useful,   
 * but WITHOUT ANY WARRANTY; without even the implied warranty of    
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     
 * GNU General Public License for more details.                      
 *                                                                   
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software       
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,            
 * MA  02111-1307, USA.                                              



 To compile this example program (change /home/fungja/xnee... to where your
  xnee package is)

 gcc -DPACKAGE_NAME=\"\" -DPACKAGE_TARNAME=\"\" -DPACKAGE_VERSION=\"\" -DPACKAGE_STRING=\"\" -DPACKAGE_BUGREPORT=\"\" -DPACKAGE=\"xnee\" -DVERSION=\"1.08\" -DHAVE_VPRINTF=1 -DSTDC_HEADERS=1 -DHAVE_SYS_TYPES_H=1 -DHAVE_SYS_STAT_H=1 -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_MEMORY_H=1 -DHAVE_STRINGS_H=1 -DHAVE_INTTYPES_H=1 -DHAVE_STDINT_H=1 -DHAVE_UNISTD_H=1 -DHAVE_STDARG_H=1  -I. -I.      -I/home/fungja/xnee-1.08/libxnee/include -I/usr/X11R6/include  -g -DUSE_VERBOSE   -DNO_BUF_VERBOSE -c ezxneemain.c
gcc -DPACKAGE_NAME=\"\" -DPACKAGE_TARNAME=\"\" -DPACKAGE_VERSION=\"\" -DPACKAGE_STRING=\"\" -DPACKAGE_BUGREPORT=\"\" -DPACKAGE=\"xnee\" -DVERSION=\"1.08\" -DHAVE_VPRINTF=1 -DSTDC_HEADERS=1 -DHAVE_SYS_TYPES_H=1 -DHAVE_SYS_STAT_H=1 -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_MEMORY_H=1 -DHAVE_STRINGS_H=1 -DHAVE_INTTYPES_H=1 -DHAVE_STDINT_H=1 -DHAVE_UNISTD_H=1 -DHAVE_STDARG_H=1  -I. -I.      -I/home/fungja/xnee-1.08/libxnee/include -I/usr/X11R6/include  -g -DUSE_VERBOSE   -DNO_BUF_VERBOSE -c /home/fungja/xnee-1.08/xnee/src/parse.c
gcc  -I../../libxnee/include -I/usr/X11R6/include  -g -DUSE_VERBOSE   -DNO_BUF_VERBOSE  -o ezxnee  ezxneemain.o parse.o   -L/usr/X11R6/lib -lXext  -lXtst -lX11 -lpthread -ldl -lxnee


 run ./ezxnee < motion.log (where motion.log should be generated by the
            normal xnee for your mahine using a --record --all-events
            invocation.  use the header and 1 line of command)

 ****/


#include <libxnee/print.h>
#include <libxnee/xnee.h>
#include <libxnee/xnee_record.h>
#include <libxnee/xnee_replay.h>
#include <libxnee/xnee_setget.h>
#include "parse.h"

int
xnee_set_info(xnee_data *xd);

static xnee_data *xd ;

int xnee_motion( int x, int y ) {
  xnee_fake_motion_event(xd,0,x,y,0);
}
int button_event( int b, int state, int msecs ) {
  if( state == 1 ) {
    xnee_fake_button_event( xd, b, True, msecs);
  }
  if( state == 0 ) {
    xnee_fake_button_event( xd, b, False, msecs);
  }
}

int close_xnee()
{
  /*
   * Close everything down .... free memory, tell X server we are leaving ...
  if ( xd->recorder || xd->sync )
    {
      xnee_record_close_down(xd);
    }
   */

  xnee_reset_autorepeat (xd);

  xnee_close_down(xd);
  exit(XNEE_OK); 
}
/**************************************************************
 *                                                            *
 * main                                                       *
 *                                                            *
 *                                                            *
 **************************************************************/
#ifndef _AS_OBJECT
int main(int argc,char *argv[])
#else
int init_xnee()
#endif
{
  int ret;
  int max;
  char ReplayFilename[] = "motion.log";


  (void) signal (SIGINT, signal_handler);

   /*
    *  
    */
  xd = xnee_new_xnee_data();

  /*
   * Init the structs. 
   */
  xnee_init(xd);
  
  /*
   * Init Recording variables
   * Since those are used when recording and replaying we 
   */
  xnee_record_init (xd);
  
  /*
   * Well .... parse the args
   *
   */
  /////xnee_parse_args (xd, argc, argv);
  xnee_set_replayer(xd);
   if ( xnee_set_data_name_byname (xd, ReplayFilename) != XNEE_OK)
     {
       xnee_print_error ("Unable to open data file\n");
       xnee_verbose ((xd, "Could not open file %s\n", ReplayFilename));
       xnee_verbose ((xd, "... leaving\n"));
       xnee_close_down(xd);
       exit(XNEE_WRONG_PARAMS);
     }

  xnee_verbose((xd, "Reading replay data from %s (%d))\n",
          xnee_get_data_name (xd),
          xnee_get_data_file (xd)));


  /*
   * The value max will indicate how many ranges was specified
   * on the command line 
   */
  max = xnee_get_max_range(xd);
  
  
  /*
   * Check if default ranges was choosen
   *
   * everything option is to be  OBSOLETED
   */
  if ( xd->xnee_info->everything || xnee_is_all_events (xd)) 
    {
      if ( max > 0 )
	{
	  xnee_print_error ("Error:\n%s, amibigous ranges\n", PACKAGE);
	  xnee_print_error (" You can't use --all-events or --everything\n");
	  xnee_print_error (" together with --event-ranges ..... \n");
	  xnee_print_error (" For syntax description type %s --help\n",
			    PACKAGE);

	  exit (XNEE_AMBIGOUS_CMD);
	}
      xnee_verbose((xd, "Choosing some of the default values as protocol\n"));
      xnee_record_select_default_protocol    (xd);
    }


  /* 
   * Print settings 
   * only done if verbose mode  
   */
  xnee_print_distr_list(xd, NULL);
  
  xnee_record_print_record_range (xd, NULL);
  
  ret=xnee_setup_recordext (xd);

  if ( xnee_is_recorder(xd) )
    {
      if (ret==XNEE_NO_PROT_CHOOSEN)
	{
	  xnee_print_error ("No protocol data choosen to record\n");
	  xnee_print_error ("You can try out with xnee --all-events\n");
	  exit(ret);
	}
    }
  
  
  /* 
   * Test Displays and Extensions  
   *
   */
  xnee_setup_display (xd);
  


  /*
   * If no recording client, init xnee_sync 
   *
   */
  if ( ! xnee_is_recorder(xd) )
    {
      xnee_replay_init (xd);   
    }
  
  
  /*
   * Save repeat mode so we can reset it after we are done
   *
   */
  xnee_set_autorepeat (xd);
  
/*
  if (xd->xnee_info->interval != 0)
    {
      xnee_delay (xd->xnee_info->interval, "xnee:" );
    }
*/
  
  
  if (xnee_is_replayer(xd))
    {
      xnee_verbose((xd, " (replayer)\n"));
      /*
       * Do we have XTest extension on the display
       *
       */ 
      if (!xnee_has_xtest_extension(xd))
	{
	  exit(XNEE_NO_TEST_EXT);
	}
      
      /*
       * Do we have XRecord extension on the display
       *
       */ 
      if (!xnee_has_record_extension(xd))
	{
	  xnee_verbose((xd, "I can't find Record extension\n"));
	  xnee_verbose((xd, "Look in the README file how to enable it\n"));
	  xnee_verbose((xd, "However, I continue without doing syncing\n"));
	  /*	  xd->sync=False;*/
	  xnee_unset_sync (xd);
	}

      XTestGrabControl (xnee_get_control_display(xd), True);
      XTestGrabControl (xnee_get_data_display(xd), True);

      /*
       * At last. Time to enter the main loop
       * ... wait to set up recording until all META data from file is read 
       * Thanks: Janice Waddick 
       */
      xnee_verbose((xd, "Entering main loop (replayer)\n"));
//      myxnee_replay_main_loop(xd);
{
  xnee_intercept_data xindata ;
  int logread = 1 ;
  int replayable ;                                                                static int last_logread=1;
  int last_elapsed = 0;
  xindata.oldtime = xindata.newtime ;
     
  /* First of all ... read up the META DATA 
   * so we know our settings */ 
  while (logread && xd->cont)
    {  
      logread = xnee_replay_read_protocol(xd, &xindata);
           
      if (!logread)
     {
       fprintf (stderr, "Could not read data from file\n");
       xnee_close_down (xd);
     }    
      else if ( logread != XNEE_META_DATA )
     {     
       /* since NULL arg printing is done when in verbose mode */
       xnee_record_print_record_range (xd, NULL);
       xnee_print_xnee_settings       (xd, NULL);

       if (xd->sync)
         {    
           xnee_setup_rep_recording(xd);
         }    
       if (xnee_is_verbose(xd))
         xnee_print_sys_info(xd , xd->out_file);
       xnee_verbose((xd, "META DATA finished .... \n"));
       break ; 
     }      
    }         
  while (logread && xd->cont)
    {
      if (!last_logread==XNEE_META_DATA)
     {
       /* 
        * set value for forthcoming time calculations 
        * Now replay starts off
        */
       last_elapsed = xnee_get_elapsed_time(xd, XNEE_FROM_LAST_READ );
     }
      logread = xnee_replay_read_protocol(xd, &xindata);

      if ( logread == XNEE_META_DATA )
     {
       xnee_verbose((xd, "META DATA read ... should be handled in the future... eg script ????\n"));
     }
      else if (logread)
     {
       if (xd->first_read_time==0)
            xd->first_read_time = xindata.newtime;

       if (xnee_check_km (xd)==XNEE_GRAB_DATA)
         {
           xnee_verbose ((xd,"\n\nsomeone grabbed us\n\n"));
         }

       switch (xindata.type)
         {
         case XNEE_EVENT:

           /* is it a device event ? */
           if ( ( xindata.u.event.type >= KeyPress )
             && (xindata.u.event.type <= MotionNotify) )
          {

            if ( xindata.u.event.type == ButtonPress )
              {
                xd->button_pressed++;
              }
            else if ( xindata.u.event.type == ButtonRelease )
              {
                xd->button_pressed--;
              }
            if ( xindata.u.event.type == KeyPress )
              {
                xd->key_pressed++;
              }
            else if ( xindata.u.event.type == KeyRelease )
              {
               xd->key_pressed--;
              }


            /*        if ( (xd->button_pressed==0) ||
                      (xd->key_pressed==0) )
                      {
            */
            xnee_replay_synchronize (xd);
            /*        */
            /*          }*/
           
            replayable = 
              xnee_replay_event_handler(xd,
                               &xindata, last_elapsed);

          }
           else
          {                                                                                 XNEE_SYNC_DEBUG ( (stderr,
                         "SYNC     EVENT   %d\n",
                         xindata.u.event.type ) );
            xnee_replay_buffer_handler (
                               xd,
                               XNEE_EVENT, 
                               xindata.u.event.type,
                               XNEE_REPLAYED);
          }
           break;
         case XNEE_REQUEST:
           xnee_verbose((xd, "READ A REQUEST, %d\n", xindata));
           xnee_replay_buffer_handler ( xd,
                            XNEE_REQUEST,
                            xindata.u.request.type,
                            XNEE_REPLAYED);
         case XNEE_REPLY:
           xnee_verbose((xd, "READ A REPLY, %d\n", xindata));
           xnee_replay_buffer_handler (  
                           xd,
                           XNEE_REPLY,
                           xindata.u.reply.type, 
                           XNEE_REPLAYED);
           break;
         default:
           xnee_verbose((xd, 
                   "xnee_replay_MainReplayLoop: Unknown type \n"));
           break;
         }    
     }      
      else    
     {          
       xnee_verbose((xd, "Corrupt line ... skipped \n"));
       break;
     }        

      XSync(xd->control, False);
      xnee_verbose((xd, "Flushing after handled event\n"));
      XFlush(xd->control);
      xnee_verbose((xd, "  <-- Flushed after handled event\n"));
      last_logread = logread;
    }
}

   /// Place all further commands here.  Link to hand tracking code.
   ///run ./xnee --replay -v < motion.log
   ///where motion.log has the appropriate header, and 1 line of action
   /// xnee_fake_motion_event(xd,0,10,10,0);
   xnee_motion(10,10);



    }
#ifndef _AS_OBJECT
  close_xnee();
#endif

}


